
#include <nds.h>
#include <malloc.h>

int main()
{	
	float xrot = 0.0f;
	float yrot = 0.0f;
	float zrot = 0.0f;
	
	// Turn on everything
	powerON(POWER_ALL);
	
	// Setup the Main screen for 3D 
	videoSetMode(MODE_0_3D);

	// IRQ basic setup
	irqInit();
	irqSet(IRQ_VBLANK, 0);

	// Set our viewport to be the same size as the screen
	glViewPort(0,0,255,191);
	
	// Specify the Clear Color and Depth 
	glClearColor(0,0,0);
	glClearDepth(0x7FFF);

	while(1)
	{
		glReset();
			
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
			
		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		glPolyFmt(POLY_ALPHA(31) | POLY_CULL_NONE);

		glRotateX(xrot);
		glRotateY(yrot);
		//glRotateZ(zrot);
			
		//En (1, 1, 1) stor RGB colourspace-kub, med origo i (0, 0, 0)
		glBegin(GL_QUADS);
			//Bakre
			glColor3f(0.0f, 0.0f, 0.0f);
			glVertex3f(-0.5f, -0.5f, -0.5f);
				
			glColor3f(1.0f, 0.0f, 0.0f);
			glVertex3f(0.5f, -0.5f, -0.5f);

			glColor3f(1.0f, 1.0f, 0.0f);
			glVertex3f(0.5f, 0.5f, -0.5f);

			glColor3f(0.0f, 1.0f, 0.0f);
			glVertex3f(-0.5f, 0.5f, -0.5f);
				
			//Frmre
			glColor3f(0.0f, 0.0f, 1.0f);
			glVertex3f(-0.5f, -0.5f, 0.5f);
				
			glColor3f(0.0f, 1.0f, 1.0f);
			glVertex3f(-0.5f, 0.5f, 0.5f);

			glColor3f(1.0f, 1.0f, 1.0f);
			glVertex3f(0.5f, 0.5f, 0.5f);

			glColor3f(1.0f, 0.0f, 1.0f);
			glVertex3f(0.5f, -0.5f, 0.5f);
				
			//Vnster
			glColor3f(0.0f, 0.0f, 0.0f);
			glVertex3f(-0.5f, -0.5f, -0.5f);
				
			glColor3f(0.0f, 1.0f, 0.0f);
			glVertex3f(-0.5f, 0.5f, -0.5f);

			glColor3f(0.0f, 1.0f, 1.0f);
			glVertex3f(-0.5f, 0.5f, 0.5f);

			glColor3f(0.0f, 0.0f, 1.0f);
			glVertex3f(-0.5f, -0.5f, 0.5f);
			
			//Hger
			glColor3f(1.0f, 0.0f, 1.0f);
			glVertex3f(0.5f, -0.5f, 0.5f);
			
			glColor3f(1.0f, 1.0f, 1.0f);
			glVertex3f(0.5f, 0.5f, 0.5f);

			glColor3f(1.0f, 1.0f, 0.0f);
			glVertex3f(0.5f, 0.5f, -0.5f);

			glColor3f(1.0f, 0.0f, 0.0f);
			glVertex3f(0.5f, -0.5f, -0.5f);
			
			//vre
			glColor3f(0.0f, 1.0f, 1.0f);
			glVertex3f(-0.5f, 0.5f, 0.5f);

			glColor3f(0.0f, 1.0f, 0.0f);
			glVertex3f(-0.5f, 0.5f, -0.5f);

			glColor3f(1.0f, 1.0f, 0.0f);
			glVertex3f(0.5f, 0.5f, -0.5f);

			glColor3f(1.0f, 1.0f, 1.0f);
			glVertex3f(0.5f, 0.5f, 0.5f);
			
			//Nedre
			glColor3f(0.0f, 0.0f, 0.0f);
			glVertex3f(-0.5f, -0.5f, -0.5f);
			
			glColor3f(0.0f, 0.0f, 1.0f);
			glVertex3f(-0.5f, -0.5f, 0.5f);

			glColor3f(1.0f, 0.0f, 1.0f);
			glVertex3f(0.5f, -0.5f, 0.5f);

			glColor3f(1.0f, 0.0f, 0.0f);
			glVertex3f(0.5f, -0.5f, -0.5f);
		glEnd();

		scanKeys();

		if((keysHeld() & KEY_RIGHT))
			yrot += 1.0f;
			
		if((keysHeld() & KEY_LEFT))
			yrot -= 1.0f;
		
		if((keysHeld() & KEY_UP))
			xrot += 1.0f;
			
		if((keysHeld() & KEY_DOWN))
			xrot -= 1.0f;

		xrot += 0.2f;
		if(xrot > 360)
			xrot = 0.0f;
		
		yrot += 0.2f;
		if(yrot > 360)
			yrot = 0.0f;
		
		zrot += 0.2f;
		if(zrot > 360)
			zrot = 0.0f;
	
		glFlush();
		//swiWaitForVBlank();
	}
	
	return 0;
}
